Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3569)
@@ -593,20 +789,166 @@
 
 
-    variable_short = TRIM( variable )
-    IF ( variable_short(1:4) /= 'bio_' ) THEN
-       found = .FALSE.
-       grid  = 'none'
-    ENDIF
-
     found = .TRUE.
-    local_pf = fill_value
-
-    SELECT CASE ( variable_short )
+    local_pf = bio_fill_value
+
+    SELECT CASE ( TRIM( variable ) )
 
 
         CASE ( 'bio_mrt_xy' )
-            grid = 'zu1'
-            two_d = .FALSE.  !< can be calculated for several levels
-            local_pf = REAL( fill_value, KIND = wp )
+           grid = 'zu1'
+           two_d = .FALSE.  !< can be calculated for several levels
+           local_pf = REAL( bio_fill_value, KIND = wp )
+           DO  l = 1, nmrtbl
+              i = mrtbl(ix,l)
+              j = mrtbl(iy,l)
+              k = mrtbl(iz,l)
+              IF ( k < nzb_do .OR. k > nzt_do .OR. j < nys .OR. j > nyn .OR.   &
+                 i < nxl .OR. i > nxr ) CYCLE
+              IF ( av == 0 )  THEN
+                 IF ( mrt_include_sw )  THEN
+                    local_pf(i,j,k) = ((human_absorb * mrtinsw(l) +            &
+                    human_emiss * mrtinlw(l)) /                                &
+                    (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
+                 ELSE
+                    local_pf(i,j,k) = (human_emiss * mrtinlw(l) /              &
+                                       sigma_sb) ** .25_wp - degc_to_k
+                 ENDIF
+              ELSE
+                 local_pf(i,j,k) = mrt_av_grid(l)
+              ENDIF
+           ENDDO
+
+
+        CASE ( 'bio_perct*_xy' )        ! 2d-array
+           grid = 'zu1'
+           two_d = .TRUE.
+           IF ( av == 0 )  THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = perct(j,i)
+                 ENDDO
+              ENDDO
+           ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = perct_av(j,i)
+                 ENDDO
+              ENDDO
+           END IF
+
+
+        CASE ( 'bio_utci*_xy' )        ! 2d-array
+           grid = 'zu1'
+           two_d = .TRUE.
+           IF ( av == 0 )  THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = utci(j,i)
+                 ENDDO
+              ENDDO
+           ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = utci_av(j,i)
+                 ENDDO
+              ENDDO
+           END IF
+
+
+        CASE ( 'bio_pet*_xy' )        ! 2d-array
+           grid = 'zu1'
+           two_d = .TRUE.
+           IF ( av == 0 )  THEN
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = pet(j,i)
+                 ENDDO
+              ENDDO
+           ELSE
+              DO  i = nxl, nxr
+                 DO  j = nys, nyn
+                    local_pf(i,j,nzb+1) = pet_av(j,i)
+                 ENDDO
+              ENDDO
+           END IF
+
+           !
+!--    Before data is transfered to local_pf, transfer is it 2D dummy variable and exchange ghost points therein. 
+!--    However, at this point this is only required for instantaneous arrays, time-averaged quantities are already exchanged. 
+       CASE ( 'uvem_vitd3*_xy' )        ! 2d-array
+          IF ( av == 0 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   local_pf(i,j,nzb+1) = vitd3_exposure(j,i)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          two_d = .TRUE.
+          grid = 'zu1'
+
+       CASE ( 'uvem_vitd3dose*_xy' )        ! 2d-array
+          IF ( av == 1 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   local_pf(i,j,nzb+1) = vitd3_exposure_av(j,i)
+                ENDDO
+             ENDDO
+          ENDIF
+
+          two_d = .TRUE.
+          grid = 'zu1'
+
+
+       CASE DEFAULT
+          found = .FALSE.
+          grid  = 'none'
+
+    END SELECT
+
+
+ END SUBROUTINE bio_data_output_2d
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining 3D output variables (dummy, always 2d!)
+!> data_output_3d 709ff
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
+
+    USE indices
+
+    USE kinds
+
+
+    IMPLICIT NONE
+!
+!-- Input variables
+    CHARACTER (LEN=*), INTENT(IN) ::  variable   !< Char identifier to select var for output
+    INTEGER(iwp), INTENT(IN) ::  av       !< Use averaged data? 0 = no, 1 = yes?
+    INTEGER(iwp), INTENT(IN) ::  nzb_do   !< Unused. 2D. nz bottom to nz top
+    INTEGER(iwp), INTENT(IN) ::  nzt_do   !< Unused.
+!
+!-- Output variables
+    LOGICAL, INTENT(OUT) ::  found   !< Output found?
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
+!
+!-- Internal variables
+    INTEGER(iwp) ::  l    !< Running index, radiation grid
+    INTEGER(iwp) ::  i    !< Running index, x-dir
+    INTEGER(iwp) ::  j    !< Running index, y-dir
+    INTEGER(iwp) ::  k    !< Running index, z-dir
+
+!     REAL(wp) ::  mrt  !< Buffer for mean radiant temperature
+
+    found = .TRUE.
+
+    SELECT CASE ( TRIM( variable ) )
+
+        CASE ( 'bio_mrt' )
+            local_pf = REAL( bio_fill_value, KIND = sp )
             DO  l = 1, nmrtbl
                i = mrtbl(ix,l)
@@ -617,147 +959,14 @@
                IF ( av == 0 )  THEN
                   IF ( mrt_include_sw )  THEN
-                     local_pf(i,j,k) = ((human_absorb * mrtinsw(l) +           &
-                     human_emiss * mrtinlw(l)) /                               &
-                     (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
+                     local_pf(i,j,k) = REAL(((human_absorb * mrtinsw(l) +      &
+                                    human_emiss * mrtinlw(l)) /                &
+                                    (human_emiss * sigma_sb)) ** .25_wp -      &
+                                    degc_to_k, kind=sp )
                   ELSE
-                     local_pf(i,j,k) = (human_emiss * mrtinlw(l) /             &
-                                        sigma_sb) ** .25_wp - degc_to_k
+                     local_pf(i,j,k) = REAL((human_emiss * mrtinlw(l) /        &
+                                    sigma_sb) ** .25_wp - degc_to_k, kind=sp )  !< why not (human_emiss * sigma_sb) as above?
                   ENDIF
                ELSE
-                  local_pf(i,j,k) = mrt_av_grid(l)
-               ENDIF
-            ENDDO
-
-
-        CASE ( 'bio_perct*_xy' )        ! 2d-array
-            grid = 'zu1'
-            two_d = .TRUE.
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = perct(j,i)
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = perct_av(j,i)
-                 ENDDO
-              ENDDO
-            END IF
-
-
-        CASE ( 'bio_utci*_xy' )        ! 2d-array
-            grid = 'zu1'
-            two_d = .TRUE.
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = utci_grid(j,i)
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = utci_av_grid(j,i)
-                 ENDDO
-              ENDDO
-            END IF
-
-
-        CASE ( 'bio_pet*_xy' )        ! 2d-array
-            grid = 'zu1'
-            two_d = .TRUE.
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = pet_grid(j,i)
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = pet_av_grid(j,i)
-                 ENDDO
-              ENDDO
-            END IF
-
-
-       CASE DEFAULT
-          found = .FALSE.
-          grid  = 'none'
-
-    END SELECT
-
-
- END SUBROUTINE bio_data_output_2d
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining 3D output variables (dummy, always 2d!)
-!> data_output_3d 709ff
-!------------------------------------------------------------------------------!
- SUBROUTINE bio_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
-
-    USE indices
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-!-- Input variables
-    CHARACTER (LEN=*), INTENT(IN) ::  variable   !< Char identifier to select var for output
-    INTEGER(iwp), INTENT(IN) ::  av       !< Use averaged data? 0 = no, 1 = yes?
-    INTEGER(iwp), INTENT(IN) ::  nzb_do   !< Unused. 2D. nz bottom to nz top
-    INTEGER(iwp), INTENT(IN) ::  nzt_do   !< Unused.
-
-!-- Output variables
-    LOGICAL, INTENT(OUT) ::  found   !< Output found?
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
-
-!-- Internal variables
-    INTEGER(iwp) ::  l    !< Running index, radiation grid
-    INTEGER(iwp) ::  i    !< Running index, x-dir
-    INTEGER(iwp) ::  j    !< Running index, y-dir
-    INTEGER(iwp) ::  k    !< Running index, z-dir
-
-    CHARACTER (LEN=:), allocatable ::  variable_short  !< Trimmed version of char variable
-
-    REAL(wp), PARAMETER ::  fill_value = -999._wp
-    REAL(wp) ::  mrt  !< Buffer for mean radiant temperature
-
-    found = .TRUE.
-    variable_short = TRIM( variable )
-
-    IF ( variable_short(1:4) /= 'bio_' ) THEN
-!--   Nothing to do, set found to FALSE and return immediatelly
-      found = .FALSE.
-      RETURN
-    ENDIF
-
-    SELECT CASE ( variable_short )
-
-        CASE ( 'bio_mrt' )
-            local_pf = REAL( fill_value, KIND = wp )
-            DO  l = 1, nmrtbl
-               i = mrtbl(ix,l)
-               j = mrtbl(iy,l)
-               k = mrtbl(iz,l)
-               IF ( k < nzb_do .OR. k > nzt_do .OR. j < nys .OR. j > nyn .OR.  &
-                  i < nxl .OR. i > nxr ) CYCLE
-               IF ( av == 0 )  THEN
-                  IF ( mrt_include_sw )  THEN
-                     local_pf(i,j,k) = ((human_absorb * mrtinsw(l) + human_emiss * mrtinlw(l)) /   &
-                                        (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
-                  ELSE
-                     local_pf(i,j,k) = (human_emiss * mrtinlw(l) /             &
-                                        sigma_sb) ** .25_wp - degc_to_k
-                  ENDIF
-               ELSE
-                  local_pf(i,j,k) = mrt_av_grid(l)
+                  local_pf(i,j,k) = REAL(mrt_av_grid(l), kind=sp)
                ENDIF
             ENDDO
@@ -780,8 +989,8 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables
     CHARACTER (LEN=*), INTENT(IN)  ::  var      !< Name of output variable
-
+!
 !-- Output variables
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x   !< x grid of output variable
@@ -790,5 +999,5 @@
 
     LOGICAL, INTENT(OUT)           ::  found    !< Flag if output var is found
-
+!
 !-- Local variables
     LOGICAL      :: is2d  !< Var is 2d?
@@ -810,5 +1019,11 @@
        grid_y = 'y'
        grid_z = 'zu'
-       IF ( is2d ) grid_z = 'zu1'
+       IF ( is2d  .AND.  var(1:7) /= 'bio_mrt' ) grid_z = 'zu1'
+    ENDIF
+
+    IF ( is2d  .AND.  var(1:4) == 'uvem' ) THEN
+       grid_x = 'x'
+       grid_y = 'y'
+       grid_z = 'zu1'
     ENDIF
 
@@ -824,8 +1039,8 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables
     INTEGER(iwp), INTENT(IN) ::  io           !< Unit of the output file
-
+!
 !-- Internal variables
     CHARACTER (LEN=86) ::  output_height_chr  !< String for output height
@@ -857,11 +1072,13 @@
         ONLY: message_string
 
+    USE netcdf_data_input_mod,                                                &
+        ONLY:  netcdf_data_input_uvem, uvem_projarea_f, uvem_radiance_f,      &
+               uvem_irradiance_f, uvem_integration_f, building_obstruction_f
+
     IMPLICIT NONE
-
+!
 !-- Internal vriables
     REAL ( wp )  :: height  !< current height in meters
-
-    INTEGER ( iwp )  :: i  !< iteration index
-
+!
 !-- Determine cell level corresponding to 1.1 m above ground level
 !   (gravimetric center of sample human)
@@ -876,67 +1093,15 @@
 
     IF ( .NOT. radiation_interactions ) THEN
-       message_string = 'The mrt calculation requires ' // &
-                        'enabled radiation_interactions but it ' // &
+       message_string = 'The mrt calculation requires ' //                     &
+                        'enabled radiation_interactions but it ' //            &
                         'is disabled!'
        CALL message( 'check_parameters', 'PAHU03', 0, 0, -1, 6, 0 )
     ENDIF
 
+!
+!-- Init UVEM and load lookup tables
+    CALL netcdf_data_input_uvem
+
  END SUBROUTINE bio_init
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Allocate biom arrays and define pointers if required
-!> init_3d_model 1047ff
-!------------------------------------------------------------------------------!
- SUBROUTINE bio_init_arrays
-
-    IMPLICIT NONE
-
-!-- Allocate a temporary array with the desired output dimensions.
-!   Initialization omitted for performance, will be overwritten anyway
-    IF ( .NOT. ALLOCATED( tmrt_grid ) ) THEN
-      ALLOCATE( tmrt_grid (nys:nyn,nxl:nxr) )
-    ENDIF
-
-    IF ( bio_perct ) THEN
-      IF ( .NOT. ALLOCATED( perct ) ) THEN
-        ALLOCATE( perct (nys:nyn,nxl:nxr) )
-      ENDIF
-    ENDIF
-
-    IF ( bio_utci ) THEN
-      IF ( .NOT. ALLOCATED( utci_grid ) ) THEN
-        ALLOCATE( utci_grid (nys:nyn,nxl:nxr) )
-      ENDIF
-    ENDIF
-
-    IF ( bio_pet ) THEN
-      IF ( .NOT. ALLOCATED( pet_grid ) ) THEN
-        ALLOCATE( pet_grid (nys:nyn,nxl:nxr) )
-      ENDIF
-    END IF
-
-    IF ( bio_perct_av ) THEN
-      IF ( .NOT. ALLOCATED( perct_av ) ) THEN
-        ALLOCATE( perct_av (nys:nyn,nxl:nxr) )
-      ENDIF
-    ENDIF
-
-    IF ( bio_utci_av ) THEN
-      IF ( .NOT. ALLOCATED( utci_av_grid ) ) THEN
-        ALLOCATE( utci_av_grid (nys:nyn,nxl:nxr) )
-      ENDIF
-    ENDIF
-
-    IF ( bio_pet_av ) THEN
-      IF ( .NOT. ALLOCATED( pet_av_grid ) ) THEN
-        ALLOCATE( pet_av_grid (nys:nyn,nxl:nxr) )
-      ENDIF
-
-    END IF
-
- END SUBROUTINE bio_init_arrays
 
 
@@ -959,5 +1124,14 @@
                                           bio_perct_av,                        &
                                           bio_utci,                            &
-                                          bio_utci_av
+                                          bio_utci_av,                         &
+                                          thermal_comfort,                     &
+!
+!-- UVEM namelist parameters
+                                          clothing,                            &
+                                          consider_obstructions,               &
+                                          orientation_angle,                   &
+                                          sun_in_south,                        &
+                                          turn_to_sun,                         &
+                                          uv_exposure
 
 
@@ -1003,4 +1177,5 @@
 
     LOGICAL, INTENT(IN)         ::  av    !< use averaged input?
+!
 !-- Internal variables
     INTEGER(iwp)                ::  i     !< Running index, x-dir, radiation coordinates
@@ -1009,8 +1184,8 @@
     INTEGER(iwp)                ::  l     !< Running index, radiation coordinates
 
-
+!
 !-- Calculate biometeorology MRT from local radiation
-!-- fluxes calculated by RTM and assign into 2D grid
-    tmrt_grid = -999.
+!   fluxes calculated by RTM and assign into 2D grid
+    tmrt_grid = bio_fill_value
     DO  l = 1, nmrtbl
        i = mrtbl(ix,l)
@@ -1042,10 +1217,10 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables
     LOGICAL,      INTENT ( IN ) ::  average_input  !< Determine averaged input conditions?
     INTEGER(iwp), INTENT ( IN ) ::  i     !< Running index, x-dir
     INTEGER(iwp), INTENT ( IN ) ::  j     !< Running index, y-dir
-
+!
 !-- Output parameters
     REAL(wp), INTENT ( OUT )    ::  tmrt  !< Mean radiant temperature        (Â°C)
@@ -1054,16 +1229,16 @@
     REAL(wp), INTENT ( OUT )    ::  ws    !< Wind speed    (local level)     (m/s)
     REAL(wp), INTENT ( OUT )    ::  pair  !< Air pressure                    (hPa)
-
+!
 !-- Internal variables
     INTEGER(iwp)                ::  k     !< Running index, z-dir
-    INTEGER(iwp)                ::  ir    !< Running index, x-dir, radiation coordinates
-    INTEGER(iwp)                ::  jr    !< Running index, y-dir, radiation coordinates
-    INTEGER(iwp)                ::  kr    !< Running index, y-dir, radiation coordinates
+!     INTEGER(iwp)                ::  ir    !< Running index, x-dir, radiation coordinates
+!     INTEGER(iwp)                ::  jr    !< Running index, y-dir, radiation coordinates
+!     INTEGER(iwp)                ::  kr    !< Running index, y-dir, radiation coordinates
     INTEGER(iwp)                ::  k_wind  !< Running index, z-dir, wind speed only
-    INTEGER(iwp)                ::  l     !< Running index, radiation coordinates
+!     INTEGER(iwp)                ::  l     !< Running index, radiation coordinates
 
     REAL(wp)                    ::  vp_sat  !< Saturation vapor pressure     (hPa)
 
-
+!
 !-- Determine cell level closest to 1.1m above ground
 !   by making use of truncation due to int cast
@@ -1076,11 +1251,12 @@
        k_wind = k + 1_iwp
     ENDIF
-
+!
 !-- Determine local values:
     IF ( average_input ) THEN
+!
 !--    Calculate ta from Tp assuming dry adiabatic laps rate
        ta = pt_av(k, j, i) - ( 0.0098_wp * dz(1) * (  k + .5_wp ) ) - degc_to_k
 
-       vp = -999._wp
+       vp = bio_fill_value
        IF ( humidity .AND. ALLOCATED( q_av ) ) THEN
           vp = q_av(k, j, i)
@@ -1091,8 +1267,9 @@
           0.5_wp * ABS( w_av(k_wind, j, i) + w_av(k_wind+1, j, i) ) )
     ELSE
+!
 !-- Calculate ta from Tp assuming dry adiabatic laps rate
        ta = pt(k, j, i) - ( 0.0098_wp * dz(1) * (  k + .5_wp ) ) - degc_to_k
 
-       vp = -999._wp
+       vp = bio_fill_value
        IF ( humidity ) THEN
           vp = q(k, j, i)
@@ -1104,5 +1281,5 @@
 
     ENDIF
-
+!
 !-- Local air pressure
     pair = surface_pressure
@@ -1116,8 +1293,9 @@
        IF ( vp > vp_sat ) vp = vp_sat
     ENDIF
-
+!
 !-- local mtr value at [i,j]
-    tmrt = -999.  !< this can be a valid result (e.g. for inside some ostacle)
+    tmrt = bio_fill_value  !< this can be a valid result (e.g. for inside some ostacle)
     IF ( radiation ) THEN
+!
 !--    Use MRT from RTM precalculated in tmrt_grid
        tmrt = tmrt_grid(j,i)
@@ -1136,58 +1314,67 @@
 
     IMPLICIT NONE
-
+!
 !-- Input attributes
     LOGICAL, INTENT ( IN ) ::  av  !< Calculate based on averaged input conditions?
-
+!
 !-- Internal variables
-    INTEGER(iwp) ::  i, j      !< Running index
-
-    REAL(wp) ::  clo           !< Clothing index                (no dimension)
-    REAL(wp) ::  ta            !< Air temperature                  (Â°C)
-    REAL(wp) ::  vp            !< Vapour pressure                  (hPa)
-    REAL(wp) ::  ws            !< Wind speed    (local level)      (m/s)
-    REAL(wp) ::  pair          !< Air pressure                     (hPa)
-    REAL(wp) ::  perct_tmp     !< Perceived temperature            (Â°C)
-    REAL(wp) ::  utci_tmp      !< Universal thermal climate index  (Â°C)
-    REAL(wp) ::  pet_tmp       !< Physiologically equivalent temperature  (Â°C)
-    REAL(wp) ::  tmrt_tmp      !< Mean radiant temperature         (Â°C)
-
-    CALL bio_init_arrays
-
+    INTEGER(iwp) ::  i, j     !< Running index
+
+    REAL(wp) ::  clo          !< Clothing index                (no dimension)
+    REAL(wp) ::  ta           !< Air temperature                  (Â°C)
+    REAL(wp) ::  vp           !< Vapour pressure                  (hPa)
+    REAL(wp) ::  ws           !< Wind speed    (local level)      (m/s)
+    REAL(wp) ::  pair         !< Air pressure                     (hPa)
+    REAL(wp) ::  perct_ij     !< Perceived temperature            (Â°C)
+    REAL(wp) ::  utci_ij      !< Universal thermal climate index  (Â°C)
+    REAL(wp) ::  pet_ij       !< Physiologically equivalent temperature  (Â°C)
+    REAL(wp) ::  tmrt_ij      !< Mean radiant temperature         (Â°C)
+
+!
 !-- fill out the MRT 2D grid from appropriate source (RTM, RRTMG,...)
-    CALL bio_calculate_mrt_grid ( av )
-
+    IF ( simulated_time > 0.0_wp ) THEN
+       CALL bio_calculate_mrt_grid ( av )
+    ENDIF
 
     DO i = nxl, nxr
        DO j = nys, nyn
+!
 !--       Determine local input conditions
-          CALL bio_get_thermal_index_input_ij ( av, i, j, ta, vp,              &
-               ws, pair, tmrt_tmp )
-!           tmrt_grid(j, i) = tmrt_tmp  !< already set by bio_calculate_mrt_grid!
-
+          tmrt_ij = bio_fill_value
+          vp      = bio_fill_value
+!
+!--       Determine input only if 
+          IF ( simulated_time > 0.0_wp ) THEN
+             CALL bio_get_thermal_index_input_ij ( av, i, j, ta, vp,           &
+                ws, pair, tmrt_ij )
+          END IF
+!
 !--       Only proceed if input is available
-          IF ( tmrt_tmp <= -998._wp .OR. vp <= -998._wp ) THEN
-             pet_tmp = -999._wp         !< set fail value, e.g. valid for within
-             perct_tmp  = -999._wp      !< some obstacle
-             utci_tmp = -999._wp
-          ELSE
+          pet_ij   = bio_fill_value   !< set fail value, e.g. valid for within
+          perct_ij = bio_fill_value   !< some obstacle
+          utci_ij  = bio_fill_value
+          IF ( .NOT. ( tmrt_ij <= -998._wp .OR. vp <= -998._wp ) ) THEN
+!
 !--          Calculate static thermal indices based on local tmrt
-             clo = -999._wp
-             
+             clo = bio_fill_value
+
              IF ( bio_perct ) THEN
+!
 !--          Estimate local perceived temperature
-                CALL calculate_perct_static( ta, vp, ws, tmrt_tmp, pair, clo,  &
-                   perct_tmp )
+                CALL calculate_perct_static( ta, vp, ws, tmrt_ij, pair, clo,   &
+                   perct_ij )
              ENDIF
-             
+
              IF ( bio_utci ) THEN
+!
 !--          Estimate local universal thermal climate index
-                CALL calculate_utci_static( ta, vp, ws, tmrt_tmp,              &
-                   bio_output_height, utci_tmp )
+                CALL calculate_utci_static( ta, vp, ws, tmrt_ij,               &
+                   bio_output_height, utci_ij )
              ENDIF
-             
+
              IF ( bio_pet ) THEN
+!
 !--          Estimate local physiologically equivalent temperature
-                CALL calculate_pet_static( ta, vp, ws, tmrt_tmp, pair, pet_tmp )
+                CALL calculate_pet_static( ta, vp, ws, tmrt_ij, pair, pet_ij )
              ENDIF
           END IF
@@ -1195,24 +1382,26 @@
 
           IF ( av ) THEN
+!
 !--          Write results for selected averaged indices
              IF ( bio_perct_av )  THEN
-                perct_av(j, i) = perct_tmp
+                perct_av(j, i) = perct_ij
              END IF
              IF ( bio_utci_av ) THEN
-                utci_av_grid(j, i) = utci_tmp
+                utci_av(j, i) = utci_ij
              END IF
              IF ( bio_pet_av ) THEN
-                pet_av_grid(j, i)  = pet_tmp
+                pet_av(j, i)  = pet_ij
              END IF
           ELSE
+!
 !--          Write result for selected indices
              IF ( bio_perct )  THEN
-                perct(j, i) = perct_tmp
+                perct(j, i) = perct_ij
              END IF
              IF ( bio_utci ) THEN
-                utci_grid(j, i) = utci_tmp
+                utci(j, i) = utci_ij
              END IF
              IF ( bio_pet ) THEN
-                pet_grid(j, i)  = pet_tmp
+                pet(j, i)  = pet_ij
              END IF
           END IF
@@ -1232,5 +1421,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Input parameters
     REAL(wp), INTENT ( IN )  ::  ta   !< Air temperature                  (Â°C)
@@ -1246,5 +1435,5 @@
                                          !  (without metabolism!)         (W)
     INTEGER(iwp), INTENT ( IN ) ::  sex  !< Sex of agent (1 = male, 2 = female)
-
+!
 !-- Both, input and output parameters
     Real(wp), INTENT ( INOUT )  ::  energy_storage    !< Energy storage   (W/mÂ²)
@@ -1253,9 +1442,11 @@
     Real(wp), INTENT ( INOUT )  ::  actlev  !< Individuals activity level
                                             !  per unit surface area      (W/mÂ²)
+!
 !-- Output parameters
     REAL(wp), INTENT ( OUT ) ::  ipt    !< Instationary perceived temp.   (Â°C)
-
+!
 !-- If clo equals the initial value, this is the initial call
     IF ( clo <= -998._wp ) THEN
+!
 !--    Initialize instationary perceived temperature with personalized 
 !      PT as an initial guess, set actlev and clo
@@ -1264,4 +1455,5 @@
           ipt )
     ELSE
+!
 !--    Estimate local instatinoary perceived temperature
        CALL ipt_cycle ( ta, vp, ws, tmrt, pair, dt, energy_storage, t_clo,     &
@@ -1287,43 +1479,71 @@
 !> www.utci.org
 !------------------------------------------------------------------------------!
- SUBROUTINE calculate_utci_static( ta_in, vp, ws_hag, tmrt, hag, utci )
+ SUBROUTINE calculate_utci_static( ta_in, vp, ws_hag, tmrt, hag, utci_ij )
 
     IMPLICIT NONE
-
+!
 !-- Type of input of the argument list
-    REAL(WP), INTENT ( IN )  ::  ta_in  !< Local air temperature (Â°C)
-    REAL(WP), INTENT ( IN )  ::  vp     !< Loacl vapour pressure (hPa)
-    REAL(WP), INTENT ( IN )  ::  ws_hag !< Incident wind speed (m/s)
-    REAL(WP), INTENT ( IN )  ::  tmrt   !< Local mean radiant temperature (Â°C)
-    REAL(WP), INTENT ( IN )  ::  hag    !< Height of wind speed input (m)
+    REAL(WP), INTENT ( IN )  ::  ta_in    !< Local air temperature (Â°C)
+    REAL(WP), INTENT ( IN )  ::  vp       !< Loacl vapour pressure (hPa)
+    REAL(WP), INTENT ( IN )  ::  ws_hag   !< Incident wind speed (m/s)
+    REAL(WP), INTENT ( IN )  ::  tmrt     !< Local mean radiant temperature (Â°C)
+    REAL(WP), INTENT ( IN )  ::  hag      !< Height of wind speed input (m)
+!
 !-- Type of output of the argument list
-    REAL(wp), INTENT ( OUT ) ::  utci   !< Universal Thermal Climate Index (Â°C)
-
-!-- Make sure precission is sufficient for regression equation
-    REAL(WP) ::  ta         !< internal air temperature (Â°C)
-    REAL(WP) ::  pa         !< air pressure in kPa      (kPa)
-    REAL(WP) ::  d_tmrt     !< delta-tmrt               (Â°C)
-    REAL(WP) ::  va         !< wind speed at 10 m above ground level    (m/s)
-    REAL(WP) ::  offset     !< utci deviation by ta cond. exceeded      (Â°C)
-
+    REAL(wp), INTENT ( OUT ) ::  utci_ij  !< Universal Thermal Climate Index (Â°C)
+
+    REAL(WP) ::  ta           !< air temperature modified by offset (Â°C)
+    REAL(WP) ::  pa           !< air pressure in kPa      (kPa)
+    REAL(WP) ::  d_tmrt       !< delta-tmrt               (Â°C)
+    REAL(WP) ::  va           !< wind speed at 10 m above ground level    (m/s)
+    REAL(WP) ::  offset       !< utci deviation by ta cond. exceeded      (Â°C)
+    REAL(WP) ::  part_ta      !< Air temperature related part of the regression
+    REAL(WP) ::  ta2          !< 2 times ta
+    REAL(WP) ::  ta3          !< 3 times ta
+    REAL(WP) ::  ta4          !< 4 times ta
+    REAL(WP) ::  ta5          !< 5 times ta
+    REAL(WP) ::  ta6          !< 6 times ta
+    REAL(WP) ::  part_va      !< Vapour pressure related part of the regression
+    REAL(WP) ::  va2          !< 2 times va
+    REAL(WP) ::  va3          !< 3 times va
+    REAL(WP) ::  va4          !< 4 times va
+    REAL(WP) ::  va5          !< 5 times va
+    REAL(WP) ::  va6          !< 6 times va
+    REAL(WP) ::  part_d_tmrt  !< Mean radiant temp. related part of the reg.
+    REAL(WP) ::  d_tmrt2      !< 2 times d_tmrt
+    REAL(WP) ::  d_tmrt3      !< 3 times d_tmrt
+    REAL(WP) ::  d_tmrt4      !< 4 times d_tmrt
+    REAL(WP) ::  d_tmrt5      !< 5 times d_tmrt
+    REAL(WP) ::  d_tmrt6      !< 6 times d_tmrt
+    REAL(WP) ::  part_pa      !< Air pressure related part of the regression
+    REAL(WP) ::  pa2          !< 2 times pa
+    REAL(WP) ::  pa3          !< 3 times pa
+    REAL(WP) ::  pa4          !< 4 times pa
+    REAL(WP) ::  pa5          !< 5 times pa
+    REAL(WP) ::  pa6          !< 6 times pa
+    REAL(WP) ::  part_pa2     !< Air pressure^2 related part of the regression
+    REAL(WP) ::  part_pa3     !< Air pressure^3 related part of the regression
+    REAL(WP) ::  part_pa46    !< Air pressure^4-6 related part of the regression
+
+!
 !-- Initialize
     offset = 0._wp
     ta = ta_in
     d_tmrt = tmrt - ta_in
-
+!
 !-- Use vapour pressure in kpa
     pa = vp / 10.0_wp
-
+!
 !-- Wind altitude correction from hag to 10m after Broede et al. (2012), eq.3
 !   z(0) is set to 0.01 according to UTCI profile definition
     va = ws_hag *  log ( 10.0_wp / 0.01_wp ) / log ( hag / 0.01_wp )
-
+!
 !-- Check if input values in range after Broede et al. (2012)
     IF ( ( d_tmrt > 70._wp ) .OR. ( d_tmrt < -30._wp ) .OR.                    &
        ( vp >= 50._wp ) ) THEN
-       utci = -999._wp
+       utci_ij = bio_fill_value
        RETURN
     ENDIF
-
+!
 !-- Apply eq. 2 in Broede et al. (2012) for ta out of bounds
     IF ( ta > 50._wp ) THEN
@@ -1335,5 +1555,5 @@
        ta = -50._wp
     ENDIF
-
+!
 !-- For routine application. For wind speeds and relative
 !   humidity values below 0.5 m/s or 5%, respectively, the
